#include <SPI.h>
#include "image.h"

////端口定义 Dreamer MEGA X1 PORT
//#define RES  46  //Gadgeteer PIN 4
//#define DC  45   //Gadgeteer PIN 5
//#define CS  53   //Gadgeteer PIN 6

////端口定义Dreamer MEGA  X2 PORT
#define RES  49  //Gadgeteer PIN 4
#define DC  47   //Gadgeteer PIN 5
#define CS  48   //Gadgeteer PIN 6


//SPI Initialization 
void spi_init(void)
{
     SPI.begin();
     SPI.setBitOrder(MSBFIRST);
     SPI.setClockDivider(SPI_CLOCK_DIV2);//SCK frequency
     SPI.setDataMode(SPI_MODE3);
}
//发送命令
void Write_Command(unsigned char COM)
{
     digitalWrite(CS,LOW);
     digitalWrite(DC,LOW);
     SPI.transfer(COM);
     digitalWrite(DC,HIGH);
     digitalWrite(CS,HIGH);
}
//发送数据
void Write_Data(unsigned char DATA)
{
     digitalWrite(CS,LOW);
     digitalWrite(DC,HIGH);
     SPI.transfer(DATA);
     digitalWrite(DC,HIGH);
     digitalWrite(CS,HIGH);
}
//OLED UG9664初始化
void SSD1331()
{
    Write_Command(0xae); //Display off
    Write_Command(0x81); //set contrast for colorA
    Write_Command(0x91); //145
    Write_Command(0x82); //set contrast for colorB
    Write_Command(0x50); //80
    Write_Command(0x83); //set contrast for colorC
    Write_Command(0x7d); //125
    Write_Command(0x87); //master current control
    Write_Command(0x06); //6
    Write_Command(0x8a); //Set Second Pre-change Speed For ColorA
    Write_Command(0x64); //100
    Write_Command(0x8b); //Set Second Pre-change Speed For ColorB
    Write_Command(0x78); //120
    Write_Command(0x8c); //Set Second Pre-change Speed For ColorC
    Write_Command(0x64); //100
    Write_Command(0xa0); //set remap & data format
    Write_Command(0x76);///76
    Write_Command(0xa1); //set display start line
    Write_Command(0x00);
    Write_Command(0xa2); //set display offset
    Write_Command(0x00);
    Write_Command(0xa4); //set display mode
    Write_Command(0xa8); //set multiplex ratio
    Write_Command(0x3f);
    Write_Command(0xad); //set master configuration
    Write_Command(0x8e);
    Write_Command(0xb0); //set power save
    Write_Command(0x0b);
    Write_Command(0xb1); //phase 1 and 2 period adjustment
    Write_Command(0x31);
    Write_Command(0xb3); //display clock divider / oscillator frequency
    Write_Command(0xf0);
    Write_Command(0xbb); //Set Pre-Change Level
    Write_Command(0x3a); //58
    Write_Command(0xbe); //set vcomh
    Write_Command(0x3e); //62
    Write_Command(0xaf); //set display on
}
//设置行列地址
void Set_Address(unsigned char a,unsigned char b,unsigned char c,unsigned char d)
{
     Write_Command(a);//set row start Address
     Write_Command(b);//set row end Address
     Write_Command(c);//set Column start Address
     Write_Command(d);//set Column end Address
}
//填充颜色
void fill(unsigned char data1,unsigned char data2)
{
    unsigned char i,j;

    Set_Address(0x00,0x3f,0x00,0x5f);

   for(i=0;i<64;i++)
    {
	for(j=0;j<96;j++)
        {
	    Write_Data(data1);
            Write_Data(data2);
        }
    }
}
//显示图片
void picture()
{
    unsigned int i,j;
    unsigned int x=0;
   
    Set_Address(0x00,0x3f,0x00,0x5f);
    
    for(i=0;i<64;i++)//64
    {
	 for(j=0;j<96;j++)//96
         {
             ram_val=pgm_read_byte(&(show1[x++]));//从flash中读取变量
	     Write_Data(ram_val);
             ram_val=pgm_read_byte(&(show1[x++]));//从flash中读取变量
	     Write_Data(ram_val);
         }
    }
}
void setup()
{
     //端口模式设置
     pinMode(RES,OUTPUT);
     pinMode(DC,OUTPUT);
     pinMode(CS,OUTPUT);
     spi_init();
}
void loop()
{
     //复位
     digitalWrite(RES,HIGH);   delay(1000);
     digitalWrite(RES,LOW);    delay(1000);
     digitalWrite(RES,HIGH);   delay(1000);
     //初始化
     SSD1331();
     delay(100);
     //红色
     fill(0x00,0x1f);
     //绿色
     fill(0x07,0xe0);
     //蓝色
     fill(0xf8,0x00);
     
     while(1)
     {
       //显示图片
       picture();
     }
}
